/*
	fnipage.c

	% inter_page

	This function is used by the standard field functions to facilitate
	movement between pages.

	Handling the inter_page movement in one place save code space and
	makes it easy to modify the inter_page behavior.  Simply replace
	inter_page with a new function that performs as desired.

	C-scape 3.1
	Copyright (c) 1986, 1987, 1988 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
*/

#include <stdio.h>
#include "cscape.h"
#include "scancode.h"

boolean inter_page(sed, scancode)
	sed_type sed;
	int scancode;
/*
	effects:	Handles movement between pages.
					PGUP	goes to the previous page.
					PGDN	goes to the next page.

	returns:	TRUE if intercepted a key, FALSE otherwise.
*/
{
	switch (scancode) {
	case PGUP:
		sed_PageUp(sed);
		return(TRUE);
	case PGDN:
		sed_PageDown(sed);
		return(TRUE);
	default:
		break;
	}
	return(FALSE);
}


