/*
	fnlong.c   	10/30/86

	% long_funcs

	Long editting functions.
	Variable should be a long*.

	C-scape 3.1
	Copyright (c) 1986, 1987, 1988 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	10/01/87 jmd 	added casting
	 5/12/88 jmd	added calls to sed_GetScratchPad()
	 9/17/88 jmd	added global error msg strings for easy changing
	 9/17/88 jmd 	added std_ funcs
	10/09/88 jmd 	added SED_ABORT support
	10/14/88 jdc	added var_size element to field_funcs_struct
*/

#include <stdio.h>
#include <ctype.h>

#include "cscape.h"
#include "fnfunc.h"			/* for field functions */
#include "strdecl.h"		/* for C-scape string functions */
#include "scancode.h"

OGLOBAL field_funcs_struct long_funcs = {
	num_fenter,
	long_fexit,
	num_fkey,
	long_senter,
	long_sexit,
	sizeof(long)
};

boolean long_fexit(sed)
	sed_type sed;
/*
	Validates a long using the string in field data 1.
*/
{
	long val;

	if (sed_GetBaton(sed) != SED_ABORT) {

		sscanf(sed_GetCurrRecord(sed), "%ld", &val);

		/* call standard numeric validation routine (fnstdval.c) */
		if (!std_NumValid(sed, (double) val)) {
			return(FALSE);
		}
	}

	return(std_fexit(sed));
}

void long_senter(sed, fieldno)
	sed_type sed;
	int fieldno;
/*
	Convert native type to string for record.
*/
{
	sprintf(sed_GetScratchPad(sed), "%ld", *((long *) sed_GetVar(sed, fieldno)));

	strright(sed_GetScratchPad(sed), sed_GetRecordLen(sed, fieldno));
	sed_SetRecord(sed, sed_GetScratchPad(sed), fieldno);

	std_senter(sed, fieldno);
}

void long_sexit(sed, fieldno)
	sed_type sed;
	int fieldno;
/*
	Converts record back to native type.
*/
{
	if (sed_GetBaton(sed) != SED_ABORT) {
		sscanf(sed_GetRecord(sed, fieldno), "%ld", (long *) sed_GetVar(sed, fieldno));
	}
}
