/*
	fnnull.c  6/06/89

	% null_funcs

	"Null" functions.
	Linked in by screen files when they encounter an undefined
	field function.

	C-scape 3.1
	Copyright (c) 1989 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
*/

#include <stdio.h>

#include "cscape.h"

void null_fkey(_arg1(sed_type));

OGLOBAL field_funcs_struct null_funcs = {
	std_fenter,
	std_fexit,
	null_fkey,
	FNULL,
	FNULL,
	0
};

void null_fkey(sed)
	sed_type sed;
/*
	Puts up an "unresolved" warning.
	Allows no editing
*/
{
	int 	scancode;

	sed_SetCurrRecord(sed, "Unresolved");
	sed_UpdateCurrField(sed);

	scancode = kb_Read();

	sed_SetCurrRecord(sed, "");
	sed_UpdateCurrField(sed);

	if (sed_DoSpecial(sed, scancode))
		return;
	if (special_key(sed, scancode))
		return;
	if (inter_field(sed, scancode))
		return;
	if (inter_page(sed, scancode))
		return;
}
