/*
	fnspec.c

	% special_key

	C-scape 3.1
	Copyright (c) 1986, 1987, 1988 by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	11/19/88 jmd	Added mouse stuff

	 6/07/89 jmd	renamed mouse codes
*/

#include <stdio.h>

#include "cscape.h"
#include "scancode.h"

#include "helpdecl.h"

boolean special_key(sed, scancode)
	sed_type sed;
	int scancode;
/*
	effects:	Handles Special Keys

	returns:	TRUE if intercepted a key, FALSE otherwise.

	normally handles FN1 as help.
	Intercepts mouse events
*/
{
	switch (scancode) {
	case MOU_HERE:
		/* The mouse was clicked in our sed,
		   the mouse handler has already Jumped to the clicked field
		   so we can just ignore this code
		*/
		return(TRUE);

	case MOU_THERE:
		/* Another window has requested control via the mouse, quit this sed */
		sed_SetBaton(sed, 0);
		sed_ToggleExit(sed);
		return(TRUE);

	case FN1:
		help_Show(sed_GetLabel(sed), sed_GetFieldNo(sed) + 1);
		return(TRUE);

	default:
		break;
	}
	return(FALSE);
}
